<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctSubMneDocProv {
    
    const NOME = "FCT_SUB_MNE_DOC_PROV";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrseqorcamento
     * @param integer $nrtipoorcamento
     * @param integer $nrorg
     */
    public function executar($nrseqorcamento, $nrtipoorcamento, $nrorg) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRSEQORCAMENTO",  Param::PARAM_INPUT,  $nrseqorcamento,  Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRTIPOORCAMENTO", Param::PARAM_INPUT,  $nrtipoorcamento, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRORG",           Param::PARAM_INPUT,  $nrorg,           Param::PARAM_TYPE_INT));
        
        $procedure->execute();
    }
    
}

?>

