DROP TYPE QUERY_ITEM_CMP99000_TABLE
/

DROP TYPE QUERY_ITEM_CMP99000_TYPE
/

CREATE TYPE QUERY_ITEM_CMP99000_TYPE AS
OBJECT(ID                VARCHAR2(100),
       IDCHECK           VARCHAR2(1),
       NRAPURPREC        VARCHAR2(10),
       CDFORNECED        VARCHAR2(21),
       CDFILSOLI         VARCHAR2(4),
       NMFILIAL          VARCHAR2(100),
       DSFILIALC         VARCHAR2(150),
       DSFILIAL          VARCHAR2(110),
       CDFILLAN          VARCHAR2(4),
       NRSOLICMP         VARCHAR2(10),
       CDPRODUTO         VARCHAR2(10),
       NMPRODUTO         VARCHAR2(50),
       CDARVPROD         VARCHAR2(20),
       SGUNIDADE         VARCHAR2(10),
       DSPRODUTO         VARCHAR2(80),
       CDMARCA           VARCHAR2(5),
       NMMARCA           VARCHAR2(20),
       DSMARCA           VARCHAR2(30),
       NRINSJURFORN      VARCHAR2(20),
       NMFANTFORN        VARCHAR2(50),
       CDEXPRODFORN      VARCHAR2(50),
       DSTIPO            VARCHAR2(15),
       DTPROGENTR        DATE,
       NRORG             NUMERIC,
       QTSOLIPROD        FLOAT,
       VRCUSTO           FLOAT,
       VRPRECUNIAP       FLOAT,
       QTDIAESTOQUE      FLOAT,
       QTCONSUMODIA      FLOAT,
       QTESTOQUE         FLOAT,
       QTDURACAEST       FLOAT,
       QTCONSUMODIASEST  FLOAT,
       QTITEMPED         FLOAT,
       QTPROGENTAF       FLOAT,
       QTENTRADAS        FLOAT,
       QTSAIDAS          FLOAT,
       VRCUSTOTOTAL      FLOAT,
       QTTOTAL           FLOAT);
/

CREATE TYPE QUERY_ITEM_CMP99000_TABLE AS TABLE OF QUERY_ITEM_CMP99000_TYPE
/

CREATE OR REPLACE FUNCTION QUERY_ITEM_CMP99000(P_CDFILCENTCMP     IN VARCHAR2,
                                               P_NRAPURPREC       IN VARCHAR2,
                                               P_CDFORNECED       IN VARCHAR2,
                                               P_CDMARCA          IN VARCHAR2,
                                               P_CDFILIAL         IN VARCHAR2,
                                               P_CDPRODINI        IN VARCHAR2,
                                               P_CDPRODFIN        IN VARCHAR2,
                                               P_TIPOTELA         IN VARCHAR2,
                                               P_CDTIPOCUSTO      IN VARCHAR2
                                               )RETURN QUERY_ITEM_CMP99000_TABLE PIPELINED
IS
   OUT_RECORD QUERY_ITEM_CMP99000_TYPE := QUERY_ITEM_CMP99000_TYPE (NULL, NULL, NULL, NULL, NULL,
                                                                    NULL, NULL, NULL, NULL, NULL,
                                                                    NULL, NULL, NULL, NULL, NULL,
                                                                    NULL, NULL, NULL, NULL, NULL,
                                                                    NULL, NULL, NULL,0, 0, 0,0, 0,
                                                                    0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
BEGIN
   FOR C_ITEM IN(SELECT CDCENTITMAP||NRSEQITMAP||CDREGITMAP||CDFORNITMAP||NRCOLEITMAP||
                        TO_CHAR(DTENTRAPUT, 'DD/MM/YYYY')||CDFILIAP||CDPRODITMAP||CDMARCITMAP ID,
                        ITMAPURPREC.CDFORNITMAP AS CDFORNECED, ITMAPURPREC.NRSEQITMAP AS NRAPURPREC,
                        'U' AS IDCHECK, FILIAL.CDFILIAL CDFILSOLI, FILIAL.NMFILIAL,
                        FILIAL.CDFILIAL || ' - ' || RPAD(SUBSTR(FILIAL.NMFILIAL, 1, 5), 5, ' ') DSFILIALC,
                        FILIAL.CDFILIAL || ' - ' || FILIAL.NMFILIAL DSFILIAL, ITMAPURPREC.CDCENTITMAP CDFILLAN,
                        NRSEQITMAP NRSOLICMP, PRODUTO.CDPRODUTO, DTENTRAPUT DTPROGENTR, QTACOMP QTSOLIPROD,
                        PRODUTO.NMPRODUTO, PRODUTO.CDARVPROD, PRODUTO.SGUNIDADE,
                        PRODUTO.CDARVPROD || ' - ' || PRODUTO.NMPRODUTO DSPRODUTO, MARCA.CDMARCA, MARCA.NMMARCA,
                        MARCA.CDMARCA || ' - ' || MARCA.NMMARCA DSMARCA, ITMAPURPREC.VRPRECUNIAP VRCUSTO,
                        (CUSTO_PRODUTO(CASE P_TIPOTELA
                                          WHEN 'G'
                                          THEN FILIAL.CDFILIAL
                                          ELSE P_CDFILCENTCMP
                                       END, PRODUTO.CDPRODESTO, P_CDTIPOCUSTO, SYSDATE, SYSDATE))*PRODUTO.VRFATOCONV VRPRECUNIAP,
                        ITMAPURPREC.NRORG, APURPRECO.QTDIAESTOQUE,
                        ITMAPURPREC.QTCONSUMODIA, ITMAPURPREC.QTESTOQUE, ITMAPURPREC.QTDURACAEST, ITMAPURPREC.QTCONSUMODIASEST,
                        ITMAPURPREC.QTITEMPED, ITMAPURPREC.QTPROGENTAF, ITMAPURPREC.QTENTRADAS, ITMAPURPREC.QTSAIDAS,
                        ITMAPURPREC.QTACOMP * VRPRECUNIAP VRCUSTOTOTAL, FORNECEDOR.NRINSJURFORN, FORNECEDOR.NMFANTFORN,
                        ITMAPURPREC.CDEXPRODFORN,
                        SUM(ITMAPURPREC.QTACOMP) OVER (PARTITION BY CDPRODITMAP, CDFORNITMAP) QTTOTAL
                   FROM ITMAPURPREC, PRODUTO, FILIAL, MARCA, APURPRECO, FORNECEDOR
                  WHERE ITMAPURPREC.CDCENTITMAP = APURPRECO.CDFILCENTCMP
                    AND ITMAPURPREC.NRSEQITMAP = APURPRECO.NRAPURPREC
                    AND ITMAPURPREC.CDCENTITMAP = P_CDFILCENTCMP
                    AND NVL(ITMAPURPREC.IDITMSELAPUR, 'N') = 'N'
                    AND ( ( INSTR(P_CDFORNECED, ITMAPURPREC.CDFORNITMAP) > 0 ) OR ( P_CDFORNECED = 'T' ) )
                    AND ITMAPURPREC.NRSEQITMAP = P_NRAPURPREC
                    AND ITMAPURPREC.CDFILIAP = FILIAL.CDFILIAL
                    AND ITMAPURPREC.CDPRODITMAP = PRODUTO.CDPRODUTO
                    AND ITMAPURPREC.CDMARCITMAP = MARCA.CDMARCA
                    AND ( ( INSTR(P_CDMARCA, ITMAPURPREC.CDMARCITMAP) > 0 ) OR ( P_CDMARCA = 'T' ) )
                    AND ( ( INSTR(P_CDFILIAL, FILIAL.CDFILIAL) > 0 ) OR ( P_CDFILIAL = 'T' ) )
                    AND ITMAPURPREC.CDFORNITMAP = FORNECEDOR.CDFORNECED
                    AND ( PRODUTO.CDARVPROD BETWEEN P_CDPRODINI AND RPAD(P_CDPRODFIN, 20, 'Z') )
                    AND NOT EXISTS (SELECT 1
                                      FROM AUTOFORNE, ITEMAUTF I
                                     WHERE I.CDFILDEST    = AUTOFORNE.CDFILDEST
                                       AND I.CDFILLANC    = AUTOFORNE.CDFILLANC
                                       AND I.NRAUTOFORN   = AUTOFORNE.NRAUTOFORN
                                       AND I.CDFILDEST    = ITMAPURPREC.CDFILIAP
                                       AND I.DTENTRITMSOL = ITMAPURPREC.DTENTRAPUT
                                       AND I.CDPRODUTO    = ITMAPURPREC.CDPRODITMAP
                                       AND I.CDMARCA      = ITMAPURPREC.CDMARCITMAP
                                       AND AUTOFORNE.NRSEQAPURAF = ITMAPURPREC.NRSEQITMAP
                                       AND AUTOFORNE.CDFORNECED = ITMAPURPREC.CDFORNITMAP))
   LOOP
      OUT_RECORD.ID               := C_ITEM.ID;
      OUT_RECORD.CDFORNECED       := C_ITEM.CDFORNECED;
      OUT_RECORD.NRAPURPREC       := C_ITEM.NRAPURPREC;
      OUT_RECORD.NRINSJURFORN     := C_ITEM.NRINSJURFORN;
      OUT_RECORD.NMFANTFORN       := C_ITEM.NMFANTFORN;
      OUT_RECORD.CDEXPRODFORN    := C_ITEM.CDEXPRODFORN;
      OUT_RECORD.IDCHECK          := C_ITEM.IDCHECK;
      OUT_RECORD.CDFILSOLI        := C_ITEM.CDFILSOLI;
      OUT_RECORD.NMFILIAL         := C_ITEM.NMFILIAL;
      OUT_RECORD.DSFILIALC        := C_ITEM.DSFILIALC;
      OUT_RECORD.DSTIPO           := 'A COMPRAR';
      OUT_RECORD.DSFILIAL         := C_ITEM.DSFILIAL;
      OUT_RECORD.CDFILLAN         := C_ITEM.CDFILLAN;
      OUT_RECORD.NRSOLICMP        := C_ITEM.NRSOLICMP;
      OUT_RECORD.CDPRODUTO        := C_ITEM.CDPRODUTO;
      OUT_RECORD.DTPROGENTR       := C_ITEM.DTPROGENTR;
      OUT_RECORD.NMPRODUTO        := C_ITEM.NMPRODUTO;
      OUT_RECORD.CDARVPROD        := C_ITEM.CDARVPROD;
      OUT_RECORD.SGUNIDADE        := C_ITEM.SGUNIDADE;
      OUT_RECORD.DSPRODUTO        := C_ITEM.DSPRODUTO;
      OUT_RECORD.CDMARCA          := C_ITEM.CDMARCA;
      OUT_RECORD.NMMARCA          := C_ITEM.NMMARCA;
      OUT_RECORD.DSMARCA          := C_ITEM.DSMARCA;
      OUT_RECORD.VRCUSTO          := C_ITEM.VRCUSTO;
      OUT_RECORD.QTSOLIPROD       := C_ITEM.QTSOLIPROD;
      OUT_RECORD.VRPRECUNIAP      := C_ITEM.VRPRECUNIAP;
      OUT_RECORD.NRORG            := C_ITEM.NRORG;
      OUT_RECORD.QTDIAESTOQUE     := C_ITEM.QTDIAESTOQUE;
      OUT_RECORD.QTCONSUMODIA     := C_ITEM.QTCONSUMODIA;
      OUT_RECORD.QTESTOQUE        := C_ITEM.QTESTOQUE;
      OUT_RECORD.QTDURACAEST      := C_ITEM.QTDURACAEST;
      OUT_RECORD.QTCONSUMODIASEST := C_ITEM.QTCONSUMODIASEST;
      OUT_RECORD.QTITEMPED        := C_ITEM.QTITEMPED;
      OUT_RECORD.QTPROGENTAF      := C_ITEM.QTPROGENTAF;
      OUT_RECORD.QTENTRADAS       := C_ITEM.QTENTRADAS;
      OUT_RECORD.QTSAIDAS         := C_ITEM.QTSAIDAS;
      OUT_RECORD.VRCUSTOTOTAL     := C_ITEM.VRCUSTOTOTAL;
      OUT_RECORD.QTTOTAL          := C_ITEM.QTTOTAL;
      IF P_TIPOTELA  = 'C' THEN
         IF C_ITEM.VRCUSTO = 0 THEN
            /*C_ITEM.VRCUSTO              := NULL;*/
            OUT_RECORD.NRINSJURFORN     := NULL;
            OUT_RECORD.NMFANTFORN       := NULL;
            OUT_RECORD. CDEXPRODFORN    := NULL;
            OUT_RECORD.CDFORNECED       := NULL;
         END IF;
         OUT_RECORD.NMPRODUTO        := RPAD(SUBSTR(C_ITEM.NMPRODUTO, 1, 20), 20, '. .');
      END IF;
      PIPE ROW (OUT_RECORD);
      IF P_TIPOTELA  = 'C' THEN
         OUT_RECORD.DSFILIALC     := C_ITEM.DSFILIALC;
         OUT_RECORD.DSTIPO        := 'ESTOQUE';
         OUT_RECORD.QTSOLIPROD    := C_ITEM.QTESTOQUE;
         PIPE ROW (OUT_RECORD);
      END IF;
   END LOOP;
END;
/