/* Sistemas Integrados TEKNISA

Nome: 1090_FINFUNS_SALDO_CONTACORR.SQL

Descrio:
FUNO PARA RETORNAR O VALOR DE SALDO DA CONTA CORRENTE.

Criao:
19/07/2007 - Rejane Priscila Leite
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'SALDO_CONTACORR'  and
            type   = 'FN'               and
            u.uid  = o.uid              and
            u.name = USER)
  DROP FUNCTION SALDO_CONTACORR
  GO

CREATE FUNCTION SALDO_CONTACORR
   (@P_CDREDUCONT VARCHAR(3),
    @P_DATAREFE   DATETIME,
    @P_IDVALOR    VARCHAR(1) = 'S') RETURNS NUMERIC
AS
BEGIN
   DECLARE @V_DATASALDO DATETIME;
   DECLARE @V_VRSALDO   NUMERIC;

  SELECT @V_DATASALDO = MAX(DTSDOCCORR)
  FROM SDOCCORR
  WHERE CDREDUCONT = @P_CDREDUCONT AND
        DTSDOCCORR  < @P_DATAREFE;

  IF @P_IDVALOR = 'I' BEGIN
     SELECT @V_VRSALDO = SUM(VRSDOIMPLA)
     FROM SDOCCORR
     WHERE CDREDUCONT = @P_CDREDUCONT AND
           DTSDOCCORR = @V_DATASALDO;
  END
  ELSE BEGIN
     SELECT @V_VRSALDO = SUM(VRSDOCCORR)
     FROM SDOCCORR
     WHERE CDREDUCONT = @P_CDREDUCONT AND
           DTSDOCCORR = @V_DATASALDO;
  END;

  RETURN (@V_VRSALDO);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'SALDO_CONTACORR','4.11.176';
GO

